﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	'NOTIFICATIONS
	Private clvNotifications As CustomListView
	Private PCLVnotifications As PreoptimizedCLV
	Private lblNoNotifications As Label
'	Private imageLoader As BitmapsAsync
	Private cs As CSBuilder
	Private MediaManager As SimpleMediaManager
	Private pnlNotificationDummy As Panel
	Private lblNotificationDummy As Label
	Private su As StringUtils
	Private totalAnnouncements As Int = 0
	Private toast As BCToast
	Private pnlToolbar As Panel
	Private btnDeleteAll As Button
	Private btnFollows As Button
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	
	Root.Color=0xFF05030F
	
'	imageLoader.Initialize
	
	MediaManager.Initialize
	MediaManager.SleepDurationBeforeDownload = 0
	MediaManager.DefaultRequestTimeout = 60000
	MediaManager.DefaultBackgroundColor = xui.Color_Transparent
	MediaManager.DefaultForegroundColor = xui.Color_Transparent
	MediaManager.DefaultErrorRequest.Extra.Put(MediaManager.REQUEST_BACKGROUND, xui.Color_Transparent)
	MediaManager.DefaultLoadingRequest.Extra.Put(MediaManager.REQUEST_BACKGROUND, xui.Color_Transparent)
	MediaManager.DefaultResizeMode = "FILL_NO_DISTORTIONS"
	MediaManager.AddLocalMedia(MediaManager.KEY_DEFAULT_ERROR, misc.FontToBitmap(misc.Chr32(0xF1B48),30,xui.Color_White), "image/*")
	MediaManager.AddLocalMedia(MediaManager.KEY_DEFAULT_LOADING, File.ReadBytes(File.DirAssets, "loading.gif"), "image/gif")
	
	#if b4a
	CreateLayout
	#End If
	
End Sub

Private Sub btnBack_Click
	totalAnnouncements = 0
	clvNotifications.Clear
	B4XPages.ClosePage(Me)
End Sub

Sub B4XPage_CloseRequest As ResumableSub
	totalAnnouncements = 0
	clvNotifications.Clear
	Return True
End Sub

Sub B4XPage_Resize (Width As Int, Height As Int)
	
	misc.ShowProgressBar("Loading...")
	
	#if b4i
	Dim r As Rect = B4XPages.GetNativeParent(Me).SafeAreaInsets
	r.Top = Max(20, r.Top)
	Root.SetLayoutAnimated(0, r.Left, r.Top, Width - r.Right - r.Left, Height - r.Bottom - r.Top)
	If Root.NumberOfViews = 0 Then CreateLayout
	#end if
	
End Sub

Sub CreateLayout As ResumableSub
	
	Root.LoadLayout("notifications")
	
	toast.Initialize(Root)
	
	PCLVnotifications.Initialize(Me, "PCLVnotifications", clvNotifications)
	
	#if b4i
	clvNotifications.Asview.Color = xui.Color_Transparent
	clvNotifications.GetBase.Height = Root.Height- pnlToolbar.Height - B4XPages.GetNativeParent(Me).SafeAreaInsets.Bottom
	btnDeleteAll.CustomLabel.Font = Font.CreateNew2("materialdesignicons",24)
	btnFollows.CustomLabel.Font = Font.CreateNew2("materialdesignicons",24)
	#End If
	
	Return Null
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

#REGION NOTIFICATIONS
Sub getAnnouncements
	
	misc.ShowProgressBar("Loading...")
	
	#if b4i
	If Root.NumberOfViews = 0 Then
		wait for B4XPage_Resize (Width As Int, Height As Int)
		Wait For (CreateLayout) Complete (Result As Object)
	End If
	#End If
	
	If clvNotifications.IsInitialized Then clvNotifications.Clear
		
	totalAnnouncements = 0
	
	Dim req As dbrequestmanager = misc.CreateRequest(Me)
	Dim cmd1 As DBCommand = misc.CreateCommand("getAnnouncements", Array(B4XPages.MainPage.user.id_gym,B4XPages.MainPage.user.id))
	Wait For (req.ExecuteQuery(cmd1, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_Result(rs As DBResult)
		'work with result
			
		For i=0 To rs.Rows.Size-1
			
			totalAnnouncements = totalAnnouncements + 1
			
			Dim Record() As Object
			Record = rs.Rows.Get(i)
				
			Private a As announcement
			a.Initialize
			a.id = Record(rs.Columns.Get("id"))
			a.id_gym = Record(rs.Columns.Get("id_gym"))
			a.id_user = Record(rs.Columns.Get("id_user"))
			a.text = Record(rs.Columns.Get("text"))
			a.date = Record(rs.Columns.Get("date"))
'			a.expire = Record(rs.Columns.Get("expire"))
			a.timestamp = Record(rs.Columns.Get("timestamp"))
			
'			Private lblHeight As Int = lblNotificationDummy.Height
'			Private pnlHeight As Int = pnlNotificationDummy.Height

			
			#If b4a
			cs.Initialize.Bold.Color(xui.Color_White).Append(B4XPages.MainPage.user.gym_name & " : ").pop.pop.Color(xui.Color_White).Append(a.text).pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(a.timestamp)).PopAll
			lblNotificationDummy.Height = su.MeasureMultilineTextHeight(lblNotificationDummy,cs)
			pnlNotificationDummy.Height = lblNotificationDummy.Top + lblNotificationDummy.Height + 10dip
			PCLVnotifications.AddItem(pnlNotificationDummy.Height + 20dip,xui.Color_Transparent,a)
			#else
			cs.Initialize.Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(B4XPages.MainPage.user.gym_name & " : ").pop.pop.Color(xui.Color_White).Append(a.text).pop.Append(CRLF).font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(a.timestamp)).PopAll	
			lblNotificationDummy.Width = Root.Width - 80
			lblNotificationDummy.AttributedText = cs
			lblNotificationDummy.SizeToFit
			pnlNotificationDummy.Height = lblNotificationDummy.Top + lblNotificationDummy.Height + 10
			PCLVnotifications.AddItem(pnlNotificationDummy.Height + 20,xui.Color_Transparent,a)
			#end if

		Next
		
	Else
		Log("ERROR: " & j.ErrorMessage)
	End If
	
	j.Release
	
	getNotifications
	
End Sub

Sub getNotifications
	
	Dim req As dbrequestmanager = misc.CreateRequest(Me)
	Dim cmd1 As DBCommand = misc.CreateCommand("getNotifications", Array(B4XPages.MainPage.user.id))
	Wait For (req.ExecuteQuery(cmd1, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_Result(rs As DBResult)
		'work with result
		
		If rs.Rows.Size = 0 And clvNotifications.Size = 0 Then
			lblNoNotifications.BringToFront
			lblNoNotifications.Visible=True
		Else
			lblNoNotifications.SendToBack
			lblNoNotifications.Visible=False
		End If
		
		For i=0 To rs.Rows.Size-1
				
			Dim Record() As Object
			Record = rs.Rows.Get(i)
				
			Private n As notificationsData
			n.Initialize
			n.id = Record(rs.Columns.Get("id"))
			n.id_user = Record(rs.Columns.Get("id_user"))
			n.id_user_sent = Record(rs.Columns.Get("id_user_sent"))
			n.surname = Record(rs.Columns.Get("surname"))
			n.name = Record(rs.Columns.Get("name"))
			n.typeNotification = Record(rs.Columns.Get("typeNotification"))
			n.id_workout = Record(rs.Columns.Get("id_workout"))
			n.photo = Record(rs.Columns.Get("photo"))
			n.timestamp = Record(rs.Columns.Get("timestamp"))
			
			#If b4a
			Select n.typeNotification
				Case "changeSubMember"
					cs.Initialize.Append("Η κατάσταση της κράτησης σας άλλαξε απο αναπληρωματικός/ή σε ").Bold.Color(xui.Color_White).Append("βασικός/ή").pop.pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "viewLogComment"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" έγραψε ενα σχόλιο στη δημοσίευση σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "followUser"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας ακολούθησε").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeTimeline"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει μια δημοσίευσή σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeComment"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα σχόλιο σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeWorkout"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα workout σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeCommentWorkout"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα σχόλιο σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "workoutComment"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" έγραψε ενα σχόλιο στο workout σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας προκάλεσε σε WOD battle!").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_won"
					cs.Initialize.Append("Δυστυχώς χάσατε απο τον χρήστη ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_lost"
					cs.Initialize.Append("Συγχαρητήρια! Κερδίσατε τον χρήστη ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_other"
					cs.Initialize.Append("Συγχαρητήρια! Ολοκληρώσατε επιτυχώς το workout battle με τον χρήστη ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battleNotify"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας υπενθύμισε να ολοκληρώσετε το WOD battle").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
			End Select
			#else
			Select n.typeNotification
				Case "changeSubMember"
					cs.Initialize.Append("Η κατάσταση της κράτησης σας άλλαξε απο αναπληρωματικός/ή σε ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append("βασικός/ή").pop.pop.Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "viewLogComment"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" έγραψε ενα σχόλιο στη δημοσίευση σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "followUser"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας ακολούθησε").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeTimeline"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει μια δημοσίευσή σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeComment"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα σχόλιο σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeWorkout"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα workout σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeCommentWorkout"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα σχόλιο σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "workoutComment"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" έγραψε ενα σχόλιο στο workout σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας προκάλεσε σε WOD battle!").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_won"
					cs.Initialize.Append("Δυστυχώς χάσατε απο τον χρήστη ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_lost"
					cs.Initialize.Append("Συγχαρητήρια! Κερδίσατε τον χρήστη ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_other"
					cs.Initialize.Append("Συγχαρητήρια! Ολοκληρώσατε επιτυχώς το workout battle με τον χρήστη ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battleNotify"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας υπενθύμισε να ολοκληρώσετε το WOD battle").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
			End Select
			#end if

			
			#If b4a
			lblNotificationDummy.Height = su.MeasureMultilineTextHeight(lblNotificationDummy,cs)
			pnlNotificationDummy.Height = lblNotificationDummy.Top + lblNotificationDummy.Height + 10dip
			PCLVnotifications.AddItem(pnlNotificationDummy.Height + 20dip,xui.Color_Transparent,n)
			#else
			lblNotificationDummy.Width = Root.Width - 80
			lblNotificationDummy.AttributedText = cs
			lblNotificationDummy.SizeToFit
			pnlNotificationDummy.Height = lblNotificationDummy.Top + lblNotificationDummy.Height + 10
			
			PCLVnotifications.AddItem(pnlNotificationDummy.Height + 20dip,xui.Color_Transparent,n)
			#end if
			

			
		Next
		
	Else
		Log("ERROR: " & j.ErrorMessage)
	End If
	
	j.Release
	
	PCLVnotifications.ShowScrollBar = False 'no fast scrolling
	PCLVnotifications.ExtraItems = 15
	PCLVnotifications.Commit
	
	misc.HideProgressBar
	
End Sub

Sub clvNotifications_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	For Each i As Int In PCLVnotifications.VisibleRangeChanged(FirstIndex, LastIndex)
		Dim item As CLVItem = clvNotifications.GetRawListItem(i)
		Dim pnl As B4XView = xui.CreatePanel("")
		item.Panel.AddView(pnl, 0, 0, item.Panel.Width, item.Panel.Height)
		
		'Create the item layout
		pnl.LoadLayout("clvNotification")
		
		If i < totalAnnouncements Then
			Dim a As announcement = item.Value
			MediaManager.SetMediaWithExtra(pnl.GetView(0).Getview(1),$"${B4XPages.MainPage.downloadLink}?name=${B4XPages.MainPage.user.gym_photo}.jpg"$,"image/*",CreateMap(MediaManager.REQUEST_ROUNDIMAGE:True, MediaManager.REQUEST_HEADERS: CreateMap("command":"image","id": B4XPages.MainPage.user.id,"token":B4XPages.MainPage.user.token)))
			
			#If b4a
			cs.Initialize.Bold.Color(xui.Color_White).Append(B4XPages.MainPage.user.gym_name & " : ").pop.pop.Color(xui.Color_White).Append(a.text).pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(a.timestamp)).PopAll
			pnl.GetView(0).GetView(0).Height = su.MeasureMultilineTextHeight(pnl.GetView(0).GetView(0),cs)
			pnl.GetView(0).GetView(0).Text = cs
			pnl.GetView(0).Height = pnl.GetView(0).GetView(0).Top + pnl.GetView(0).GetView(0).Height + 10dip
			#else
			cs.Initialize.Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(B4XPages.MainPage.user.gym_name & " : ").pop.pop.Color(xui.Color_White).Append(a.text).pop.Append(CRLF).font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(a.timestamp)).PopAll
			pnl.GetView(0).GetView(0).As(Label).Width = Root.Width - 80
			pnl.GetView(0).GetView(0).As(Label).AttributedText = cs
			pnl.GetView(0).GetView(0).As(Label).SizeToFit
			pnl.GetView(0).Height = pnl.GetView(0).GetView(0).Top + pnl.GetView(0).GetView(0).Height + 10
			#end if

			pnl.GetView(0).Color = 0xFFFF4A4A 'red color
			pnl.GetView(0).GetView(2).Visible = False
		Else
			Dim n As notificationsData = item.Value
			If n.photo <> Null Then MediaManager.SetMediaWithExtra(pnl.GetView(0).Getview(1),$"${B4XPages.MainPage.downloadLink}?name=${n.photo}.jpg"$,"image/*",CreateMap(MediaManager.REQUEST_ROUNDIMAGE:True, MediaManager.REQUEST_HEADERS: CreateMap("command":"image","id": B4XPages.MainPage.user.id,"token":B4XPages.MainPage.user.token)))
			#If b4a
			Select n.typeNotification
				Case "changeSubMember"
					cs.Initialize.Append("Η κατάσταση της κράτησης σας άλλαξε απο αναπληρωματικός/ή σε ").Bold.Color(xui.Color_White).Append("βασικός/ή").pop.pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "viewLogComment"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" έγραψε ενα σχόλιο στη δημοσίευση σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "followUser"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας ακολούθησε").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeTimeline"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει μια δημοσίευσή σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeComment"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα σχόλιο σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeWorkout"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα workout σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeCommentWorkout"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα σχόλιο σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "workoutComment"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" έγραψε ενα σχόλιο στο workout σας").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας προκάλεσε σε WOD battle!").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_won"
					cs.Initialize.Append("Δυστυχώς χάσατε απο τον χρήστη ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_lost"
					cs.Initialize.Append("Συγχαρητήρια! Κερδίσατε τον χρήστη ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_other"
					cs.Initialize.Append("Συγχαρητήρια! Ολοκληρώσατε επιτυχώς το workout battle με τον χρήστη ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battleNotify"
					cs.Initialize.Append("Ο χρήστης ").Bold.Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας υπενθύμισε να ολοκληρώσετε το WOD battle").Append(CRLF).Typeface(Typeface.CreateNew(Typeface.DEFAULT,Typeface.STYLE_ITALIC)).Size(9).Append(misc.returnDateTime(n.timestamp)).PopAll
			End Select
			
			pnl.GetView(0).GetView(0).Height = su.MeasureMultilineTextHeight(pnl.GetView(0).GetView(0),cs)
			pnl.GetView(0).GetView(0).Text=cs
			pnl.GetView(0).Height = pnl.GetView(0).GetView(0).Top + pnl.GetView(0).GetView(0).Height + 10dip
			#else
			Select n.typeNotification
				Case "changeSubMember"
					cs.Initialize.Append("Η κατάσταση της κράτησης σας άλλαξε απο αναπληρωματικός/ή σε ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append("βασικός/ή").pop.pop.Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "viewLogComment"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" έγραψε ενα σχόλιο στη δημοσίευση σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "followUser"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας ακολούθησε").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeTimeline"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει μια δημοσίευσή σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeComment"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα σχόλιο σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeWorkout"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα workout σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "likeCommentWorkout"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" δήλωσε οτι του αρέσει ενα σχόλιο σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "workoutComment"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" έγραψε ενα σχόλιο στο workout σας").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας προκάλεσε σε WOD battle!").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_won"
					cs.Initialize.Append("Δυστυχώς χάσατε απο τον χρήστη ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_lost"
					cs.Initialize.Append("Συγχαρητήρια! Κερδίσατε τον χρήστη ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battle_other"
					cs.Initialize.Append("Συγχαρητήρια! Ολοκληρώσατε επιτυχώς το workout battle με τον χρήστη ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
				Case "battleNotify"
					cs.Initialize.Append("Ο χρήστης ").Font(Font.DEFAULT_BOLD).Color(xui.Color_White).Append(n.surname & " " & n.name).pop.pop.Append(" σας υπενθύμισε να ολοκληρώσετε το WOD battle").Append(CRLF).Font(Font.CreateNewItalic(9)).Append(misc.returnDateTime(n.timestamp)).PopAll
			End Select
			
			pnl.GetView(0).GetView(0).As(Label).Width = Root.Width - 80
			pnl.GetView(0).GetView(0).As(Label).AttributedText=cs
			pnl.GetView(0).GetView(0).As(Label).SizeToFit
			pnl.GetView(0).Height = pnl.GetView(0).GetView(0).Top + pnl.GetView(0).GetView(0).Height + 10
			#end if
			

			
		End If
		
	Next
	
	MediaManager.TrimMediaCache
	
End Sub

Private Sub clvNotifications_ItemClick (Index As Int, Value As Object)
	
	If Index >= totalAnnouncements Then
		
		Dim n As notificationsData = Value
		
		Select n.typeNotification
			Case "changeSubMember"
				B4XPages.ClosePage(Me)
				B4XPages.MainPage.tabMenu_TabClick(1)
			Case "viewLogComment"
				B4XPages.ShowPage("viewLogPage")
				B4XPages.MainPage.viewLogPage.getWorkoutLog(n.id_workout)
			Case "followUser"
				B4XPages.ShowPage("followsPage")
				B4XPages.MainPage.followsPage.getFollows
	'			openBottomFriendRequest(n,Index)
			Case "likeTimeline"
				B4XPages.ShowPage("viewLogPage")
				B4XPages.MainPage.viewLogPage.getWorkoutLog(n.id_workout)
			Case "likeComment"
				B4XPages.ShowPage("viewLogPage")
				B4XPages.MainPage.viewLogPage.getWorkoutLog(n.id_workout)
			Case "likeWorkout"
				B4XPages.ClosePage(Me)
				B4XPages.MainPage.tabMenu_TabClick(0)
				B4XPages.MainPage.datePickerWorkouts.SelectedDate=DateTime.DateParse(n.id_workout)
				B4XPages.MainPage.workoutsCount(n.id_workout)
				B4XPages.MainPage.datePickerWorkouts.Refresh
			Case "likeCommentWorkout"
				B4XPages.ClosePage(Me)
				B4XPages.MainPage.tabMenu_TabClick(0)
				B4XPages.MainPage.datePickerWorkouts.SelectedDate=DateTime.DateParse(n.id_workout)
				B4XPages.MainPage.workoutsCount(n.id_workout)
				B4XPages.MainPage.datePickerWorkouts.Refresh
			Case "workoutComment"
				B4XPages.ClosePage(Me)
				B4XPages.MainPage.tabMenu_TabClick(0)
				B4XPages.MainPage.datePickerWorkouts.SelectedDate=DateTime.DateParse(n.id_workout)
				B4XPages.MainPage.workoutsCount(n.id_workout)
				B4XPages.MainPage.datePickerWorkouts.Refresh
			Case "battle_won"
	'			B4XPages.ClosePage(Me)
				B4XPages.ShowPage("battlesPage")
				B4XPages.MainPage.battlesPage.countBattles
			Case "battle_lost"
	'			B4XPages.ClosePage(Me)
				B4XPages.ShowPage("battlesPage")
				B4XPages.MainPage.battlesPage.countBattles
			Case "battle_other"
	'			B4XPages.ClosePage(Me)
				B4XPages.ShowPage("battlesPage")
				B4XPages.MainPage.battlesPage.countBattles
			Case "battleNotify"
	'			B4XPages.ClosePage(Me)
				B4XPages.ShowPage("battlesPage")
				B4XPages.MainPage.battlesPage.countBattles
		End Select
		
	End If
End Sub



Private Sub deleteNotification(n As notificationsData,index As Int)
		
	Dim req As dbrequestmanager = misc.CreateRequest(Me)
	Dim cmd1 As DBCommand = misc.CreateCommand("deleteNotification", Array(n.id))
	Wait For (req.ExecuteCommand(cmd1, Null)) JobDone(j As HttpJob)
	If j.Success Then
		clvNotifications.RemoveAt(index)
	Else
		toast.Show("ERROR: " & j.ErrorMessage)
		Log("ERROR: " & j.ErrorMessage)
	End If
	
	j.Release
	
End Sub

Private Sub lblDelete_Click
		
	Private index As Int = clvNotifications.GetItemFromView(Sender)
	Dim n As notificationsData = clvNotifications.GetValue(clvNotifications.GetItemFromView(Sender))
	Log(n.id)
	
	Dim req As dbrequestmanager = misc.CreateRequest(Me)
	Dim cmd1 As DBCommand = misc.CreateCommand("deleteNotification", Array(n.id))
	Wait For (req.ExecuteCommand(cmd1, Null)) JobDone(j As HttpJob)
	If j.Success Then
		clvNotifications.RemoveAt(index)
	Else
		toast.Show("ERROR: " & j.ErrorMessage)
		Log("ERROR: " & j.ErrorMessage)
	End If
	
	j.Release
	
End Sub

Private Sub btnDeleteAll_Click
	
	If clvNotifications.Size = 0 Then Return
	
	#if b4a
	Dim sf As Object = xui.Msgbox2Async("Θέλετε να διαγραφούν όλες οι ειδοποιήσεις σας;", "Fitbook", "Ναι", "", "Οχι", Null)
	misc.SetColorAndBorder(sf,0xFF1A1924,0,xui.Color_Magenta,10dip)
	misc.SetTextColor(sf,xui.Color_White,xui.Color_White,0xFF00954E)
	#else
	xui.Msgbox2Async("Θέλετε να διαγραφούν όλες οι ειδοποιήσεις σας;", "Fitbook", "Ναι", "", "Οχι", Null)
	#end if
	Wait For Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then 'DialogResponse.POSITIVE Then
		Dim req As dbrequestmanager = misc.CreateRequest(Me)
		Dim cmd1 As DBCommand = misc.CreateCommand("deleteAllNotifications", Array(B4XPages.MainPage.user.id))
		Wait For (req.ExecuteCommand(cmd1, Null)) JobDone(j As HttpJob)
		If j.Success Then
			clvNotifications.Clear
			
			lblNoNotifications.BringToFront
			lblNoNotifications.Visible=True
		Else
			toast.Show("ERROR: " & j.ErrorMessage)
			Log("ERROR: " & j.ErrorMessage)
		End If
	
		j.Release
	End If

End Sub

Sub insertNotification(idUser As String,typeNotification As String, selectedIdWorkout As String)
	
	Dim req As dbrequestmanager = misc.CreateRequest(Me)
	Dim cmd1 As DBCommand = misc.CreateCommand("insertNotification", Array(idUser,B4XPages.MainPage.user.id,typeNotification,selectedIdWorkout))
	Wait For (req.ExecuteCommand(cmd1, Null)) JobDone(j As HttpJob)
	If j.Success Then
		Log("insertNotification completed")
		
		If clvNotifications.IsInitialized Then
			If clvNotifications.Size= 0 Then
				lblNoNotifications.BringToFront
				lblNoNotifications.Visible=True
			End If
		End If
		
	Else
		toast.Show("ERROR: " & j.ErrorMessage)
		Log("ERROR: " & j.ErrorMessage)
	End If
	
	j.Release
	
End Sub

Private Sub btnFollows_Click
	
	B4XPages.ShowPage("followsPage")
	B4XPages.MainPage.followsPage.getFollows
	
End Sub
#End Region

#Region downloadImage
'Sub DownloadAndSetImage(bmp As B4XBitmap, photo_url As String, id As String, iv As B4XImageView)
'	Dim j As HttpJob
'	j.Initialize("", Me)
'	j.Download2(B4XPages.MainPage.downloadLink,Array As String("name", photo_url & ".jpg"))
'	Wait For (j) JobDone (j As HttpJob)
'	If j.Success Then
'		Try
'			'the item might have already been removed
'			If iv.mBase.Parent.Parent.IsInitialized Then
'				Wait For (imageLoader.LoadFromHttpJob(j, 500dip, 500dip)) Complete (bmp As B4XBitmap)
'				If bmp.IsInitialized And iv.mBase.Parent.IsInitialized Then
'					iv.Tag=id
'					iv.Bitmap = bmp
'				End If
'			End If
'		Catch
'			Log(LastException)
'		End Try
'	End If
'	j.Release
'End Sub
#End Region